/* $Id: structs.h 9 2006-07-07 09:45:23Z cedric $ */

#ifndef STRUCTS_H
#define STRUCTS_H

typedef struct{
        char from_ip[16];
        char from_addr[130];
        char from_name[387];
	char to_ip[16];
        char to_addr[130];
        char to_name[387];
        char *text;
} msg;
        
typedef struct msg_lst_{
        msg *message;
        struct msg_lst_ *next;
        struct msg_lst_ *prev;
        
} msg_lst_p;
typedef msg_lst_p* msg_lst;

typedef struct{
        char addr[130];
        char name[387];
} cnt;
        
typedef struct cnt_lst_{
        cnt *contact;
        struct cnt_lst_ *next;
        struct cnt_lst_ *prev;
        
} cnt_lst_p;
typedef cnt_lst_p* cnt_lst;
        
typedef struct{ 
        char ip[16];
	char addr[130];
	char name[387];
	int nbrc;
	int nbrm;
        cnt_lst contacts;
        msg_lst messages;
} usr;
        
typedef struct usr_lst_{
        usr *user;
        struct usr_lst_ *next;
        struct usr_lst_ *prev;

} usr_lst_p;
typedef usr_lst_p* usr_lst;

struct users{
	int nbru;
	usr_lst lst;
}usrs;

usr_lst usr_first;


msg *msgAllocate();
void msgDestroy(msg *v);
msg_lst InsertMsgFirst(msg_lst l,char *from_ip,char *from_addr, char *from_name, char *to_ip, char *to_addr, char *to_name, char *text);
void EmptyMsglist(msg_lst l);
void PrintMsglist(msg_lst l);

cnt *cntAllocate();
void cntDestroy(cnt *v);
cnt_lst InsertCntFirst(cnt_lst l);
void EmptyCntlist(cnt_lst l);
void PrintCntlist(cnt_lst l);

usr *usrAllocate(char *ip);
void usrDestroy(usr *v);
usr_lst InsertUsrFirst(usr_lst l, char *ip,char *addr,char *name);
void EmptyUsrlist(usr_lst l);
void PrintUsrlist(usr_lst l);

int FindifexistCnt(cnt_lst l,char *addr);
cnt_lst FindCnt(cnt_lst l,char *addr);

int FindifexistUsr(usr_lst l,char *ip);
usr_lst FindUsr(usr_lst l,char *ip);

void SaveLogs(usr_lst l, char *fname);
#endif // STRUCTS_H
